Unit tde98e4_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UtRes_p, ftde98e4_p, DE98E_p;

function tde98e4: String;

implementation

function tde98e4: String;
var
M0,K0,INIAPR,IMAX,MESTER,K20,IMAX2,NATTEM,JSTART,NX,KP1,KP2,KP3,L,J,
   IERR :Integer;
X,YX,DYX,H,HMIN,HMAX,XP,YT,DYT,XK :Extended;
BUL :Boolean;
sBUL : String;  //   BUL
YP :Array [0..0] of Extended;
DYP :Array [0..0] of Extended;
DELTY :Array [0..0] of Extended;
RO :Array [0..0] of Extended;
YX2 :Array [0..0] of Extended;
DYX2 :Array [0..0] of Extended;
XJ0 :Array [0..17] of Extended;
AU :Array [0..20] of Extended;
ADU :Array [0..19] of Extended;
AJK :Array [0..18] of Extended;
XJ02 :Array [0..26] of Extended;
AU2 :Array [0..29] of Extended;
ADU2 :Array [0..28] of Extended;
AJK2 :Array [0..27] of Extended;
AJKP :Array [0..18] of Extended;
U :Array [0..17] of Extended;
DU :Array [0..17] of Extended;
U2 :Array [0..26] of Extended;
DU2 :Array [0..26] of Extended;
HD4I :Array [0..27] of Extended;
RABC :Array [0..26] of Extended;
RABC1 :Array [0..26] of Extended;
RABC2 :Array [0..28] of Extended;
RABC3 :Array [0..28] of Extended;
ALP :Array [0..17] of Extended;
ALPN :Array [0..17] of Extended;
CMAR :Array [0..323] of Extended;
P :Array [0..169] of Extended;
ALP2 :Array [0..26] of Extended;
ALPN2 :Array [0..26] of Extended;
CMAR2 :Array [0..728] of Extended;
S :Array [0..188] of Extended;
ZFI :Array [0..21] of Extended;
ZFI2 :Array [0..29] of Extended;
IU :Array [0..1] of Integer;
EPS :Array [0..1] of Extended;
THRESH :Array [0..1] of Extended;
MEXACT :Array [0..1] of Integer;
NUMBES :Array [0..1] of Integer;
const
K :Integer = 18;
K2 :Integer = 27;
M :Integer = 1;
label
_10,_1,_2,_3,_4,_5,_6,_20;
begin
Result := '';  {   }
IU[0] := 2;
IU[1] := 2;
EPS[0] := 0.5e-11;
Eps[1] := 0.5e-11;
THRESH[0] := 1.e0;
THRESH[1] := 1.e0;
MEXACT[0] := 1;
MEXACT[1] := 1;
NUMBES[0] := 1;
NUMBES[1] := 1;
{  }
{       Extended PRECISION Q,YT,DYT,XK }
{  }
{        take into consideraitoin: all arraies dependent on K }
{               must be described for maximal value K }
{  }
M0 := M;
_BLOCK.elm2 := 4.0e0;
{  }
_BLOCK.elm1 := 0;
_STAT76.elm2 := 0;
_STAT76.elm1 := 0;
{  }
X := 0.0;
YX := Exp(_BLOCK.elm2);
DYX := _BLOCK.elm2*YX;
XK := 7.e0;
K0 := 12;
INIAPR := 1;
IMAX := 23;
MESTER := 1;
H := 1.e0;
HMIN := 1.e-3;
HMAX := XK;
K20 := 25;
IMAX2 := 3;
NATTEM := 3;
{  }
JSTART := 0;
BUL := False;
{  }
for NX:=1 to 7 do
 begin
  Result := Result + Format(' JSTART (input) =%1d ',[JSTART]) + #$0D#$0A;
  DE98E(ftde98e4,M0,K0,INIAPR,IMAX,JSTART,YX,DYX,X,IU,EPS,THRESH,
       H,HMIN,HMAX,BUL,XP,YP,DYP,MEXACT,NUMBES,DELTY,RO,
       MESTER, K20,IMAX2,YX2,DYX2,NATTEM,AU,ADU,AJK,AU2,
       ADU2,AJK2,XJ0,XJ02,AJKP,U,DU,U2,DU2,ZFI,ZFI2,
       HD4I,RABC,RABC1,RABC2,RABC3,
       ALP,ALPN,CMAR,P,S,ALP2,ALPN2,CMAR2,IERR);
{  }
  if BUL   //   
   then sBUL := 'True'
   else sBUL := 'False';
{  }
  YT := Exp(_BLOCK.elm2*(X+1.e0));
  DYT := _BLOCK.elm2*YT;
  Result := Result + Format(''+#$0D#$0A+' RESULTS AFTER %1d ',[NX]);
  Result := Result + Format('%s',
 ['-nd    CALL Procedure DE98E']) + #$0D#$0A;
  Result := Result + Format(' IERR=%2d    N=%5d    NACCEP=%3d    NREJEC=%3d    BUL=%s',
 [IERR,_BLOCK.elm1,_STAT76.elm1,_STAT76.elm2,sBUL]) + #$0D#$0A;
  Result := Result + Format(' XP=%30.18e      X=%30.18e ',
 [XP,X]) + #$0D#$0A;
  Result := Result + Format(' H =%30.18e    K =%2d    INIAPR=%1d    IMAX =%2d    JSTART (exit) =%1d  '+#$0D#$0A+'                               K2=%2d               IMAX2=%2d ',
 [H,K0,INIAPR,IMAX,JSTART,K20,IMAX2]) + #$0D#$0A;
  Result := Result + Format(' It is advisable to take the next segment H = %30.18e ',
 [H]) + #$0D#$0A;
  Result := Result + Format(' YX =%30.18e         DYX =%30.18e '+#$0D#$0A+' YT =%30.18e         DYT =%30.18e  '+#$0D#$0A+' (YT-YX)/YX =%30.18e     (DYT-DYX)/DYX =%30.18e '+#$0D#$0A+'',
 [YX,DYX,YT,DYT,(YT-YX)/YX,(DYT-DYX)/DYX]) + #$0D#$0A;
{  }
  Result := Result + Format('            Coefficients AU, ADU and AJK  on %3d ',
 [NX]);
  Result := Result + Format('%s',['  segment  ']) + #$0D#$0A;
  KP1 := K0+1;
  KP2 := K0+2;
  KP3 := K0+3;
{  }
  for L:=1 to M do
   begin
    Result := Result + Format('%s',
 [' ----------------------------------------------------------------' + #$0D#$0A]);
    Result := Result + Format('   Number of               Chebyshev coefficients for %1d ',
 [L]);
    Result := Result + Format('%s',
 [' component'+#$0D#$0A+'              ------------------------------------------------------------------------'+#$0D#$0A+' coefficient         for Y                  for Y''                  for Y'''''+#$0D#$0A+' -------------------------------------------------------------------------------------']) + #$0D#$0A;
   for J:=1 to KP1 do
     begin
    Result := Result + Format('  %2d  %30.18e %30.18e %30.18e ',[
(J-1),AU[(L-1)+(J-1)],ADU[(L-1)+(J-1)],AJK[(L-1)+(J-1)]]) + #$0D#$0A;
     end;
    Result := Result + Format('  %2d  %30.18e %30.18e '+#$0D#$0A+'  %2d  %30.18e ',
 [KP1,AU[(L-1)+(KP2-1)],ADU[(L-1)+(KP2-1)],KP2,AU[(L-1)+(KP3-1)]]) + #$0D#$0A;
_10:
   end;
{  }
  Result := Result + Format('%s',
 [' ****************************************************************' + #$0D#$0A]);
{  }
  case NX of
   1: goto _1;
   2: goto _2;
   3: goto _3;
   4: goto _4;
   5: goto _5;
   6: goto _6;
   7: goto _20;
  end;
{  }
{   take into consideraitoin: parameter JSTART must be equal to zero }
{  }
_1:
  JSTART := 0;
{  }
  K0 := 16;
  IMAX := 25;
  goto _20;
{  }
{   take into consideraitoin: parameter JSTART must be equal to zero }
{  }
_2:
  JSTART := 0;
{  }
  K0 := 17;
  IMAX := 24;
  goto _20;
{  }
{   take into consideraitoin: parameter JSTART must be equal to zero }
{  }
_3:
  JSTART := 0;
{  }
  K0 := 18;
  IMAX := 25;
  goto _20;
{  }
{   take into consideraitoin: parameter JSTART must be equal to zero }
{  }
_4:
  JSTART := 0;
{  }
  K20 := 26;
  goto _20;
{  }
{   take into consideraitoin: parameter JSTART must be equal to zero }
{  }
_5:
  JSTART := 0;
{  }
  K20 := 27;
  goto _20;
{  }
{   take into consideraitoin: parameter JSTART must be equal to zero }
{  }
_6:
  JSTART := 0;
{  }
  K0 := 12;
  IMAX := 23;
  K20 := 25;
{  }
  H := XK-X;
  BUL := True;
{  }
_20:
 end;
{ 2 }
UtRes('tde98e4',Result);  {     tde98e4.xt }
exit;
end;

end.
